require 'spec_helper'

describe Puppet::Type.type("evs").provider(:solaris) do
  let (:provider) { subject }
  let(:properties) do
    {:ensure=>nil, :maxbw=>nil, :priority=>nil, :protection=>nil, :l2_type=>nil, :vlanid=>nil, :vni=>nil, :uuid=>nil}
  end
  let(:resource) { subject.new(properties) }

  it 'should return an array of instances' do
    expect(subject.instances).to be_instance_of(Array)
  end

  describe 'getter property methods' do
    it "should return value for ensure property" do
      expect(resource.ensure).to eq(nil)
    end
    it "should return value for maxbw property" do
      expect(resource.maxbw).to eq(nil)
    end
    it "should return value for priority property" do
      expect(resource.priority).to eq(nil)
    end
    it "should return value for protection property" do
      expect(resource.protection).to eq(nil)
    end
    it "should return value for l2_type property" do
      expect(resource.l2_type).to eq(nil)
    end
    it "should return value for vlanid property" do
      expect(resource.vlanid).to eq(nil)
    end
    it "should return value for vni property" do
      expect(resource.vni).to eq(nil)
    end
    it "should return value for uuid property" do
      expect(resource.uuid).to eq(nil)
    end
  end

  describe 'setter property methods' do
    it "should allow setting of value for ensure property" do
      resource.ensure = 'value1'
      expect(resource.ensure).to eq('value1')
    end
    it "should allow setting of value for maxbw property" do
      resource.maxbw = 'value1'
      expect(resource.maxbw).to eq('value1')
    end
    it "should allow setting of value for priority property" do
      resource.priority = 'value1'
      expect(resource.priority).to eq('value1')
    end
    it "should allow setting of value for protection property" do
      resource.protection = 'value1'
      expect(resource.protection).to eq('value1')
    end
    it "should allow setting of value for l2_type property" do
      resource.l2_type = 'value1'
      expect(resource.l2_type).to eq('value1')
    end
    it "should allow setting of value for vlanid property" do
      resource.vlanid = 'value1'
      expect(resource.vlanid).to eq('value1')
    end
    it "should allow setting of value for vni property" do
      resource.vni = 'value1'
      expect(resource.vni).to eq('value1')
    end
    it "should allow setting of value for uuid property" do
      resource.uuid = 'value1'
      expect(resource.uuid).to eq('value1')
    end
  end
end
