require 'spec_helper'

describe Puppet::Type.type("evs_ipnet").provider(:solaris) do
  let (:provider) { subject }
  let(:properties) do
    {:ensure=>nil, :subnet=>nil, :defrouter=>nil, :uuid=>nil, :pool=>nil}
  end
  let(:resource) { subject.new(properties) }

  it 'should return an array of instances' do
    expect(subject.instances).to be_instance_of(Array)
  end

  describe 'getter property methods' do
    it "should return value for ensure property" do
      expect(resource.ensure).to eq(nil)
    end
    it "should return value for subnet property" do
      expect(resource.subnet).to eq(nil)
    end
    it "should return value for defrouter property" do
      expect(resource.defrouter).to eq(nil)
    end
    it "should return value for uuid property" do
      expect(resource.uuid).to eq(nil)
    end
    it "should return value for pool property" do
      expect(resource.pool).to eq(nil)
    end
  end

  describe 'setter property methods' do
    it "should allow setting of value for ensure property" do
      resource.ensure = 'value1'
      expect(resource.ensure).to eq('value1')
    end
    it "should allow setting of value for subnet property" do
      resource.subnet = 'value1'
      expect(resource.subnet).to eq('value1')
    end
    it "should allow setting of value for defrouter property" do
      resource.defrouter = 'value1'
      expect(resource.defrouter).to eq('value1')
    end
    it "should allow setting of value for uuid property" do
      resource.uuid = 'value1'
      expect(resource.uuid).to eq('value1')
    end
    it "should allow setting of value for pool property" do
      resource.pool = 'value1'
      expect(resource.pool).to eq('value1')
    end
  end
end
