require 'spec_helper'

describe Puppet::Type.type("evs_properties").provider(:solaris) do
  let (:provider) { subject }
  let(:properties) do
    {:l2_type=>nil, :uplink_port=>nil, :uri_template=>nil, :vlan_range=>nil, :vxlan_addr=>nil, :vxlan_ipvers=>nil, :vxlan_mgroup=>nil, :vxlan_range=>nil, :controller=>nil}
  end
  let(:resource) { subject.new(properties) }

  it 'should return an array of instances' do
    expect(subject.instances).to be_instance_of(Array)
  end

  describe 'getter property methods' do
    it "should return value for l2_type property" do
      expect(resource.l2_type).to eq(nil)
    end
    it "should return value for uplink_port property" do
      expect(resource.uplink_port).to eq(nil)
    end
    it "should return value for uri_template property" do
      expect(resource.uri_template).to eq(nil)
    end
    it "should return value for vlan_range property" do
      expect(resource.vlan_range).to eq(nil)
    end
    it "should return value for vxlan_addr property" do
      expect(resource.vxlan_addr).to eq(nil)
    end
    it "should return value for vxlan_ipvers property" do
      expect(resource.vxlan_ipvers).to eq(nil)
    end
    it "should return value for vxlan_mgroup property" do
      expect(resource.vxlan_mgroup).to eq(nil)
    end
    it "should return value for vxlan_range property" do
      expect(resource.vxlan_range).to eq(nil)
    end
    it "should return value for controller property" do
      expect(resource.controller).to eq(nil)
    end
  end

  describe 'setter property methods' do
    it "should allow setting of value for l2_type property" do
      resource.l2_type = 'value1'
      expect(resource.l2_type).to eq('value1')
    end
    it "should allow setting of value for uplink_port property" do
      resource.uplink_port = 'value1'
      expect(resource.uplink_port).to eq('value1')
    end
    it "should allow setting of value for uri_template property" do
      resource.uri_template = 'value1'
      expect(resource.uri_template).to eq('value1')
    end
    it "should allow setting of value for vlan_range property" do
      resource.vlan_range = 'value1'
      expect(resource.vlan_range).to eq('value1')
    end
    it "should allow setting of value for vxlan_addr property" do
      resource.vxlan_addr = 'value1'
      expect(resource.vxlan_addr).to eq('value1')
    end
    it "should allow setting of value for vxlan_ipvers property" do
      resource.vxlan_ipvers = 'value1'
      expect(resource.vxlan_ipvers).to eq('value1')
    end
    it "should allow setting of value for vxlan_mgroup property" do
      resource.vxlan_mgroup = 'value1'
      expect(resource.vxlan_mgroup).to eq('value1')
    end
    it "should allow setting of value for vxlan_range property" do
      resource.vxlan_range = 'value1'
      expect(resource.vxlan_range).to eq('value1')
    end
    it "should allow setting of value for controller property" do
      resource.controller = 'value1'
      expect(resource.controller).to eq('value1')
    end
  end
end
