require 'spec_helper'

describe Puppet::Type.type("evs_vport").provider(:solaris) do
  let (:provider) { subject }
  let(:properties) do
    {:ensure=>nil, :cos=>nil, :maxbw=>nil, :priority=>nil, :protection=>nil, :ipaddr=>nil, :macaddr=>nil, :uuid=>nil}
  end
  let(:resource) { subject.new(properties) }

  it 'should return an array of instances' do
    expect(subject.instances).to be_instance_of(Array)
  end

  describe 'getter property methods' do
    it "should return value for ensure property" do
      expect(resource.ensure).to eq(nil)
    end
    it "should return value for cos property" do
      expect(resource.cos).to eq(nil)
    end
    it "should return value for maxbw property" do
      expect(resource.maxbw).to eq(nil)
    end
    it "should return value for priority property" do
      expect(resource.priority).to eq(nil)
    end
    it "should return value for protection property" do
      expect(resource.protection).to eq(nil)
    end
    it "should return value for ipaddr property" do
      expect(resource.ipaddr).to eq(nil)
    end
    it "should return value for macaddr property" do
      expect(resource.macaddr).to eq(nil)
    end
    it "should return value for uuid property" do
      expect(resource.uuid).to eq(nil)
    end
  end

  describe 'setter property methods' do
    it "should allow setting of value for ensure property" do
      resource.ensure = 'value1'
      expect(resource.ensure).to eq('value1')
    end
    it "should allow setting of value for cos property" do
      resource.cos = 'value1'
      expect(resource.cos).to eq('value1')
    end
    it "should allow setting of value for maxbw property" do
      resource.maxbw = 'value1'
      expect(resource.maxbw).to eq('value1')
    end
    it "should allow setting of value for priority property" do
      resource.priority = 'value1'
      expect(resource.priority).to eq('value1')
    end
    it "should allow setting of value for protection property" do
      resource.protection = 'value1'
      expect(resource.protection).to eq('value1')
    end
    it "should allow setting of value for ipaddr property" do
      resource.ipaddr = 'value1'
      expect(resource.ipaddr).to eq('value1')
    end
    it "should allow setting of value for macaddr property" do
      resource.macaddr = 'value1'
      expect(resource.macaddr).to eq('value1')
    end
    it "should allow setting of value for uuid property" do
      resource.uuid = 'value1'
      expect(resource.uuid).to eq('value1')
    end
  end
end
