require 'spec_helper'

describe Puppet::Type.type("ip_interface").provider(:solaris) do
  let (:provider) { subject }
  let(:properties) do
    {:ensure=>nil}
  end
  let(:resource) { subject.new(properties) }

  it 'should return an array of instances' do
    expect(subject.instances).to be_instance_of(Array)
  end

  describe 'getter property methods' do
    it "should return value for ensure property" do
      expect(resource.ensure).to eq(nil)
    end
  end

  describe 'setter property methods' do
    it "should allow setting of value for ensure property" do
      resource.ensure = 'value1'
      expect(resource.ensure).to eq('value1')
    end
  end
end
