require 'spec_helper'

describe Puppet::Type.type("ip_tunnel").provider(:solaris) do
  let (:provider) { subject }
  let(:properties) do
    {:ensure=>nil, :tunnel_type=>nil, :local_address=>nil, :remote_address=>nil}
  end
  let(:resource) { subject.new(properties) }

  it 'should return an array of instances' do
    expect(subject.instances).to be_instance_of(Array)
  end

  describe 'getter property methods' do
    it "should return value for ensure property" do
      expect(resource.ensure).to eq(nil)
    end
    it "should return value for tunnel_type property" do
      expect(resource.tunnel_type).to eq(nil)
    end
    it "should return value for local_address property" do
      expect(resource.local_address).to eq(nil)
    end
    it "should return value for remote_address property" do
      expect(resource.remote_address).to eq(nil)
    end
  end

  describe 'setter property methods' do
    it "should allow setting of value for ensure property" do
      resource.ensure = 'value1'
      expect(resource.ensure).to eq('value1')
    end
    it "should allow setting of value for tunnel_type property" do
      resource.tunnel_type = 'value1'
      expect(resource.tunnel_type).to eq('value1')
    end
    it "should allow setting of value for local_address property" do
      resource.local_address = 'value1'
      expect(resource.local_address).to eq('value1')
    end
    it "should allow setting of value for remote_address property" do
      resource.remote_address = 'value1'
      expect(resource.remote_address).to eq('value1')
    end
  end
end
