require 'spec_helper'

describe Puppet::Type.type("solaris_vlan").provider(:solaris) do
  let (:provider) { subject }
  let(:properties) do
    {:ensure=>nil, :lower_link=>nil, :vlanid=>nil}
  end
  let(:resource) { subject.new(properties) }

  it 'should return an array of instances' do
    expect(subject.instances).to be_instance_of(Array)
  end

  describe 'getter property methods' do
    it "should return value for ensure property" do
      expect(resource.ensure).to eq(nil)
    end
    it "should return value for lower_link property" do
      expect(resource.lower_link).to eq(nil)
    end
    it "should return value for vlanid property" do
      expect(resource.vlanid).to eq(nil)
    end
  end

  describe 'setter property methods' do
    it "should allow setting of value for ensure property" do
      resource.ensure = 'value1'
      expect(resource.ensure).to eq('value1')
    end
    it "should allow setting of value for lower_link property" do
      resource.lower_link = 'value1'
      expect(resource.lower_link).to eq('value1')
    end
    it "should allow setting of value for vlanid property" do
      resource.vlanid = 'value1'
      expect(resource.vlanid).to eq('value1')
    end
  end
end
